<?php
declare(strict_types=1);

namespace Inti\Filter;

use Laminas\Filter\Callback;
use Laminas\Filter\FilterChain;
use Laminas\Filter\PregReplace;
use Laminas\Filter\StringToLower;
use Laminas\Filter\StringTrim;
use Laminas\Filter\StripTags;

/**
 * Class SanitizeTitle
 *
 * @package Inti\Filter
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-filter
 */
class CreateSlug extends FilterChain
{
    public function __construct($options = null)
    {
        parent::__construct($options);

        $this->attach(new Callback('rawurldecode'));
        $this->attach(new StripTags());
        $this->attach(new RemoveAccents());
        $this->attach(new StringToLower());
        $this->attach(new PregReplace(['pattern' => '/[^a-z0-9]+/', 'replacement' => '-']));
        $this->attach(new StringTrim(' -'));
    }
}
