<?php
declare(strict_types=1);

namespace Inti\Filter;

use function explode;
use function implode;

/**
 * Class SanitizePath
 *
 * @package Inti\Filter
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-filter
 */
final class SanitizePath extends CreateSlug
{
    public function filter($value): string
    {
        $path = explode('/', $value);

        foreach ($path as &$component) {
            $parts = explode('.', $component);

            foreach ($parts as &$part) {
                $part = parent::filter($part);
            }

            $component = implode('.', $parts);
        }

        return implode('/', $path);
    }
}
